/**
 *
 */
package com.sample;

import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;

import org.drools.process.instance.WorkItemHandler;
import org.drools.runtime.ObjectFilter;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;
import org.drools.runtime.rule.FactHandle;

public class InsertWorkItemHandler implements WorkItemHandler {

	private StatefulKnowledgeSession ksession;

	public InsertWorkItemHandler(StatefulKnowledgeSession ksession) {
		this.ksession = ksession;
	}

	/**
	 * {@inheritDoc}
	 */
	public void abortWorkItem(WorkItem arg0, WorkItemManager arg1) {
		// TODO Auto-generated method stub
	}

	/**
	 * {@inheritDoc}
	 */
	public void executeWorkItem(WorkItem workItem, WorkItemManager manager) {
		new Thread(
	            new Runnable() {
	                public void run() {
	                	try {
	                		insertFact();
	                		insertFact();
	                		updateFact();
	                		updateFact();
	                	} catch (Exception e) {
	                		e.printStackTrace();
	                	}
	                }

	                private void insertFact() throws Exception {
                        Thread.sleep(2000);
	                    System.out.println(String.format("%s Inserting SimpleFact", new SimpleDateFormat("dd/MM/yyy HH:mm:ss").format(new Date())));
	            		ksession.insert(new SimpleFact());
	                }

	                private void updateFact() throws Exception {
                        Thread.sleep(2000);
                        Collection<FactHandle> factHandles = ksession.getFactHandles(new ObjectFilter() {
                            public boolean accept(Object object) {
                                return (object instanceof SimpleFact);
                            }
                        });
                        for (FactHandle factHandle : factHandles) {
                        	SimpleFact simpleFact = (SimpleFact) ksession.getObject(factHandle);
                            simpleFact.setComplete(true);
    	                    System.out.println(String.format("%s Updating SimpleFact", new SimpleDateFormat("dd/MM/yyy HH:mm:ss").format(new Date())));
                            ksession.update(factHandle, simpleFact);
                            break;
                        }
	                }
	            }).start();
		System.out.println(String.format("%s Thread launched", new SimpleDateFormat("dd/MM/yyy HH:mm:ss").format(new Date())));
		manager.completeWorkItem(workItem.getId(), null);
	}
}
